<template>
  <client-only>
    <div class="relative bg-secondary-100">
      <section>
        <div class="grid grid-cols-12 gap-0">
          <div class="col-span-12 px-10 py-16 bg-white lg:col-span-9">
            <div
              class="flex items-center justify-between pb-5 border-b border-secondary-200"
            >
              <h3 class="text-xl font-medium">Shopping Cart</h3>
              <h3 class="text-xl font-medium">
                {{
                  this.$store.state.cart.cart
                    ? this.$store.state.cart.cart.contents.itemCount
                    : 0
                }}
                Items
              </h3>
            </div>

            <ul class="mt-10">
              <!-- Heading -->
              <li class="hidden grid-cols-5 md:grid">
                <div class="col-span-2">
                  <h3
                    class="text-base font-medium uppercase text-secondary-300"
                  >
                    Product details
                  </h3>
                </div>
                <div class="col-span-1 text-center">
                  <h3
                    class="text-base font-medium uppercase text-secondary-300"
                  >
                    Quantity
                  </h3>
                </div>
                <div class="col-span-1 text-center">
                  <h3
                    class="text-base font-medium uppercase text-secondary-300"
                  >
                    Price
                  </h3>
                </div>
                <div class="col-span-1 text-center">
                  <h3
                    class="text-base font-medium uppercase text-secondary-300"
                  >
                    Total
                  </h3>
                </div>
              </li>
              <!-- Content -->
              <client-only v-if="this.$store.state.cart.cart">
                <li
                  v-for="(product, index) in this.$store.state.cart.cart
                    .contents.nodes"
                  :key="index"
                  class="grid grid-cols-5 py-2 pl-2 border-b hover:bg-secondary-100 hover:shadow-sm border-secondary-100"
                >
                  <div class="col-span-5 md:col-span-2">
                    <div
                      class="flex items-center justify-around md:justify-start"
                    >
                      <div class="bg-secondary-200">
                        <nuxt-link
                          :to="{
                            name: 'shop-slug',
                            params: {
                              slug: product.product.node.slug,
                              productType: product.product.node.type,
                            },
                          }"
                          class="block border border-white shadow-md hover:border-primary-200"
                        >
                          <img
                            v-lazy="product.product.node.productImages.image"
                            class="object-contain object-center h-20"
                            :alt="product.product.node.name"
                          />
                        </nuxt-link>
                      </div>
                      <div class="ml-5">
                        <nuxt-link
                          :to="{
                            name: 'shop-slug',
                            params: {
                              slug: product.product.node.slug,
                              productType: product.product.node.type,
                            },
                          }"
                          class="mb-2 text-sm text-secondary-300 hover:text-primary-300"
                        >
                          <h3 title="Product name">
                            {{
                              product.product.node.name
                                .split(' - ')[1]
                                .replace(/--/g, '')
                                .replace(/_/g, ' ')
                            }}
                          </h3>
                        </nuxt-link>
                        <span
                          class="block mb-1 text-base font-semibold"
                          title="Brand"
                        >
                          {{ product.product.node.name.split(' - ')[0] }}
                        </span>
                        <span
                          v-if="product.product.node.type === 'VARIABLE'"
                          class="block mb-3 text-xs"
                        >
                          <span class="capitalize">
                            {{
                              product.variation.attributes[0].name.split(
                                'pa_'
                              )[1]
                            }}
                          </span>
                          {{ product.variation.attributes[0].value }}
                        </span>
                        <button
                          class="flex items-center justify-start text-xs text-secondary-200 hover:text-primary-300 focus:outline-none"
                          @click="removeItem(index)"
                        >
                          <span class="mr-1">
                            <i class="text-xs bx bx-trash"></i>
                          </span>
                          <span>Remove</span>
                        </button>
                      </div>
                    </div>
                  </div>

                  <div
                    class="flex items-center justify-center col-span-5 mt-3 md:col-span-1 md:mt-0"
                  >
                    <span>
                      {{ product.quantity }}
                    </span>
                  </div>

                  <div
                    class="flex items-center justify-center col-span-5 mt-3 md:col-span-1 md:mt-0"
                  >
                    <h3
                      v-if="!product.product.node.onSale"
                      class="text-base font-semibold"
                      title="Price"
                    >
                      {{ product.product.node.price }}
                    </h3>
                    <h3 v-else class="text-base font-semibold text-right">
                      <del
                        class="text-xs text-secondary-200"
                        title="Regular price"
                      >
                        {{ product.product.node.regularPrice }}
                      </del>
                      <br />
                      <span title="Sale price">{{
                        product.product.node.salePrice
                      }}</span>
                    </h3>
                  </div>

                  <div
                    class="flex items-center justify-center col-span-5 mt-3 md:col-span-1 md:mt-0"
                  >
                    <span class="mr-3 text-sm font-semibold">TOTAL:</span>
                    <span>
                      {{ product.total }}
                    </span>
                  </div>
                </li>
              </client-only>
            </ul>

            <div class="flex items-center justify-between mt-10">
              <div>
                <nuxt-link
                  to="/shop"
                  class="flex items-center justify-center text-primary-300 hover:text-primary-400"
                >
                  <i class="mr-2 text-3xl bx bx-chevron-left"></i>
                  Continue Shopping
                </nuxt-link>
              </div>
              <div></div>
            </div>
          </div>

          <div class="col-span-12 px-10 py-16 lg:col-span-3">
            <div
              class="flex items-center justify-between w-full pb-5 border-b border-secondary-200"
            >
              <h3 class="text-xl font-medium">Order Summary</h3>
            </div>

            <!-- <div class="pb-10 mt-10 border-b border-secondary-200">
              <div
                v-if="
                  this.$store.state.cart.cart.availableShippingMethods.length >
                  0
                "
                class="mt-5"
              >
                <client-only>
                  <label class="block">
                    <span class="font-semibold text-black">Shipping</span>

                    <select
                      id="rates-input"
                      ref="rates-input"
                      v-model="formValues.rate"
                      class="block w-full mt-1 form-select text-secondary-300"
                    >
                      <option
                        v-for="(rate, index) in this.$store.state.cart.cart
                          .availableShippingMethods[0].rates"
                        :key="index"
                        :value="rate.methodId"
                      >
                        {{ rate.label }}
                      </option>
                    </select>
                  </label>
                </client-only>
              </div>

              <div class="mt-5">
                <client-only>
                  <label class="block">
                    <span class="font-semibold text-black">Promo Code</span>

                    <input
                      id="code-input"
                      ref="code-input"
                      v-model="formValues.coupon"
                      type="text"
                      class="block w-full mt-1 form-input"
                      placeholder="Enter your code"
                    />
                  </label>
                </client-only>
              </div>
            </div> -->

            <div class="mt-10">
              <div class="flex items-center justify-between mb-3">
                <div>
                  <span class="font-semibold text-secondary-400">
                    Subtotal
                  </span>
                </div>
                <div>
                  <span class="text-secondary-400">
                    {{
                      this.$store.state.cart.cart
                        ? this.$store.state.cart.cart.subtotal
                        : 0
                    }}
                  </span>
                </div>
              </div>

              <div class="flex items-center justify-between mb-3">
                <div>
                  <span class="font-semibold text-secondary-400">Shipping</span>
                </div>
                <div>
                  <span class="text-secondary-400">
                    {{
                      this.$store.state.cart.cart
                        ? this.$store.state.cart.cart.shippingTotal
                        : 0
                    }}
                  </span>
                </div>
              </div>

              <div class="flex items-center justify-between mb-3">
                <div>
                  <span class="font-semibold text-secondary-400">Tax</span>
                </div>
                <div>
                  <span class="text-secondary-400">
                    {{
                      this.$store.state.cart.cart
                        ? this.$store.state.cart.cart.totalTax
                        : 0
                    }}
                  </span>
                </div>
              </div>
              <client-only v-if="this.$store.state.cart.cart">
                <div
                  v-if="this.$store.state.cart.cart.appliedCoupons"
                  class="flex items-center justify-between mb-3"
                >
                  <div>
                    <span class="font-semibold text-secondary-400"
                      >Discount</span
                    >
                  </div>
                  <div>
                    <span class="text-primary-200">
                      - {{ this.$store.state.cart.cart.discountTotal }}
                    </span>
                  </div>
                </div>
              </client-only>

              <div class="flex items-center justify-between">
                <div>
                  <span class="text-xl font-semibold text-black">Total</span>
                </div>
                <div>
                  <span>
                    {{
                      this.$store.state.cart.cart
                        ? this.$store.state.cart.cart.total
                        : 0
                    }}
                  </span>
                </div>
              </div>
            </div>

            <div class="mt-5">
              <!-- <button
                class="btn secondary small"
                :disabled="!needUpdate"
                @click.prevent="updateCart"
              >
                Update
              </button> -->
              <button
                class="mt-3 btn large"
                :class="[
                  { primary: this.$store.state.cart.cart },
                  {
                    'pointer-events-none secondary opacity-50': !this.$store
                      .state.cart.cart,
                  },
                ]"
                @click="$router.push('checkout')"
              >
                Checkout
              </button>
            </div>
          </div>
        </div>
      </section>
    </div>
  </client-only>
</template>

<script>
export default {
  data() {
    return {}
  },
  methods: {
    removeItem(index) {
      this.$store.dispatch('cart/removeItem', index)
    },
  },
}
</script>
